/* This file is part of GNU Libraries and Engines for Games  -*- c++ -*-

   $Id: boundingentity.h,v 1.1 2004/07/15 23:26:02 jd Exp $

   Created 07/03/04 by Jean-Dominique Frattini <zionarea@free.fr>
   
   Copyright (c) 2004 Free Software Foundation
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
/*! \file libs/physics/boundingentity.h
  \brief an entity that bounds.
*/

#ifndef LEG_LIBS_PHYSICS_BOUNDING_ENTITY_H
#define LEG_LIBS_PHYSICS_BOUNDING_ENTITY_H

#include "simpleentity.h"

namespace leg
{
namespace libs
{
namespace physics
{

class BoundingEntity: public SimpleEntity
{
   protected:

   real coef;
   
   BoundingEntity (const BoundingEntity& e);
   
   public:

   BoundingEntity();
   
   const BoundingEntity& 
   operator = (const BoundingEntity& e);

   ~BoundingEntity();

   void
   UpdateGravity (Vector& g, real height);

   protected:

   void
   Copy (const BoundingEntity& e);
};

}
}
}

#endif
