/* This file is part of GNU Libraries and Engines for Games  -*- c++ -*-

   $Id: infos.h,v 1.3 2004/06/15 07:18:53 jd Exp $

   Created 03/10/04 by Jean-Dominique Frattini <zionarea@free.fr>
   
   Copyright (c) 2004 Free Software Foundation
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
/*! \file support/utils/infos.h
  \brief Output for simple message informations.
*/

#ifndef LEG_SUPPORT_UTILS_INFOS_H
#define LEG_SUPPORT_UTILS_INFOS_H

#include "issue.h"

namespace leg
{
namespace support
{
namespace utils
{
namespace error
{

//! Support for info handlings.
/*!
 * Support for info handlings.
 *
 * status:
 *    unset.
 *
 * info:
 *    none.
 */
struct Info: public Issue
{
   Info ();
   explicit Info (const std::string& msg);
   explicit Info (const std::string& msg, const std::string& location);
   explicit Info (const std::string& msg, const std::string& location, int strerr_val);
};

}
}
}
}
#endif
