/* This file is part of GNU Libraries and Engines for Games  -*- c++ -*-

   $Id: firsttypes.h,v 1.4 2004/05/09 23:33:35 jd Exp $

   Created 02/17/04 by Jean-Dominique Frattini <zionarea@free.fr>
   
   Copyright (c) 2004 Free Software Foundation
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
/*! \file support/window/firsttypes.h
  \brief first types needed for windowing support
*/

#ifndef LEG_SUPPORT_WINDOW_SDL_FIRSTTYPE_H
#define LEG_SUPPORT_WINDOW_SDL_FIRSTTYPE_H

#include <SDL/SDL.h>

#ifndef WIN32
#include <GL/glx.h>
#include <X11/extensions/xf86vmode.h>
#endif

namespace leg
{
namespace support
{

//! Support for windowing.
/*!
 * This defines things needed to support windowing, rendering, keyboard and 
 * mouse interactivities.
 */
namespace window
{
namespace internal
{

typedef SDL_Surface* Window;
typedef int	     Context;
typedef int	     FbConfig;
typedef int	     Drawable;
typedef SDL_Event    Event;
#ifndef WIN32
typedef ::Display    Display;
#else
typedef int	     Display;
#endif
typedef SDLKey	     Key;
typedef unsigned int MouseButton; // as defined by X.
typedef int	     VisualInfo;

}
}
}
}
#endif
