/* This file is part of GNU Libraries and Engines for Games.

   $Id: infinitelight.cc,v 1.2 2004/07/03 20:15:05 jd Exp $
   $Log: infinitelight.cc,v $
   Revision 1.2  2004/07/03 20:15:05  jd
   graphics no more depend on scene, first release

   Revision 1.1  2004/04/30 20:15:54  jechk
   Big merge.  See ChangeLog for details.


   Created 4/22/04 by Jeff Binder <bindej@rpi.edu>
   
   Copyright (c) 2004 Free Software Foundation
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
/*! \file infinitelight.cc
  \brief A light type for infinite lights such as the Sun.
*/

#include "leg/libs/graphics/lighting/infinitelight.h"

namespace leg
{
namespace libs
{
namespace graphics
{

namespace lighting
{

void
InfiniteLight::EnableLight ()
{
}

void
InfiniteLight::DrawLight ()
{
  GLfloat pos[] = { loc.x, loc.y, loc.z, 0.0 };
  glLightfv (GetLightTag (), GL_POSITION, pos);
}

}

}
}
}
