/* This file is part of GNU Libraries and Engines for Games.

   $Id: entity.cc,v 1.5 2004/07/03 20:15:22 jd Exp $

   Created 04/02/05 by J-D Frattini <zionarea@free.fr>
   
   Copyright (c) 2004-2005 Free Software Foundation
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
/*! \file simplecamera.cc
  \brief a simple camera.
*/

#include "leg/libs/scene/simplecamera.h"
#include <iostream>

namespace leg
{
namespace libs
{
namespace scene
{

const std::string SimpleCamera::main_id   = "LegCamera";
const std::string SimpleCamera::sub_id    = "LegSimpleCamera";
   
SimpleCamera::SimpleCamera(): Camera()
{
}
      
SimpleCamera::SimpleCamera (const SimpleCamera& c):
   Camera (static_cast<const Camera&> (c))
{
}

void
SimpleCamera::Init()
{
   CalculateUpVector();
}

void
SimpleCamera::Update()
{
   CalculateUpVector();
}

SimpleCamera*
SimpleCamera::Clone()
{
   return new SimpleCamera (*this);
}

void
SimpleCamera::Read (std::ifstream& ifs)
{
   Camera::Read (ifs);
}

void
SimpleCamera::Write (std::ofstream& ofs)
{
   Camera::Write (ofs);
}

void
SimpleCamera::Copy (const SimpleCamera& c)
{
   Camera::Copy (static_cast<const Camera&> (c));
}

const Entity::Propriety
SimpleCamera::GetPropriety() const
{
   return Entity::camera_object;
}

}
}
}
