/* This file is part of GNU Libraries and Engines for Games.

   $Id: quadrics.cc,v 1.1 2004/04/30 20:15:54 jechk Exp $
   $Log: quadrics.cc,v $
   Revision 1.1  2004/04/30 20:15:54  jechk
   Big merge.  See ChangeLog for details.


   Created 4/25/04 by Jeff Binder <bindej@rpi.edu>
   
   Copyright (c) 2004 Free Software Foundation
   
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU General Public
   License along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
/*! \file quadrics.cc
  \brief Support for GLU's quadrics (for rendering spheres, disks, etc.
*/

#include "leg/support/graphics/quadrics.h"
#include "leg/support/utils/error.h"

namespace leg
{
namespace support
{
namespace graphics
{

void
QuadricError ()
{
  throw utils::Error ("Quadrics error");
}

Quadric::Quadric ()
  : quadric (gluNewQuadric ()),
    orientation (GLU_OUTSIDE),
    draw_style (GLU_FILL),
    normals (GLU_NONE),
    texture_coords (GLU_FALSE)
{
  gluQuadricCallback (quadric, GLU_ERROR, QuadricError);
}

}
}
}
